/******************************** -*- C -*- ****************************
 *
 *	Emulation for getdtablesize
 *
 *	$Revision: 1.95.1$
 *	$Date: 2000/12/27 10:45:49$
 *	$Author: pb$
 *
 ***********************************************************************/

/***********************************************************************
 *
 * Copyright 1988-92, 1994-95, 1999, 2000 Free Software Foundation, Inc.
 * Written by Paolo Bonzini.
 *
 * This file is part of GNU Smalltalk.
 *
 * GNU Smalltalk is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later 
 * version.
 * 
 * GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 *
 ***********************************************************************/

#ifdef HAVE_CONFIG_H
#include "gstconf.h"
#endif

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif 

#ifdef HAVE_SYS_PARAM_H
#include <sys/param.h>
#endif

#ifdef HAVE_GETRUSAGE
# include <sys/resource.h>
#endif

#ifndef HAVE_GETDTABLESIZE
int
getdtablesize()
{
#ifdef _SC_OPEN_MAX            /* POSIX -- preferred */
  int tableSize = sysconf(_SC_OPEN_MAX);
#else
  int tableSize = -1;
#endif

#ifdef RLIMIT_NOFILE           /* who is non POSIX but has this? */
  struct rlimit res;
  if (tableSize >= 0)
    return tableSize;

  if (getrlimit(RLIMIT_NOFILE, &rlimit) != -1)
    tableSize = rlimit.rlim_max;
#endif

  if (tableSize >= 0)
    return tableSize;

#ifdef OPEN_MAX
  return OPEN_MAX;
#else
#ifdef NOFILE
  return NOFILE;
#else
  /* If something went wrong, choose a safe >>>hack<<< value */
  return sizeof(short) * 8;
#endif
#endif    
}
#endif

