"======================================================================
|
|   Driver for the ANSI-compliancy tests
|
|   $Revision: 1.95.1$
|   $Date: 2000/12/27 10:45:49$
|   $Author: pb$
|
 ======================================================================"


"======================================================================
|
| Copyright (C) 2000  Free Software Foundation.
| Written by Paolo Bonzini
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 2, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
| Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
|
 ======================================================================"

Transcript message: stderr -> #nextPutAllFlush:!
FileStream fileIn: 'load-tests.st' ifMissing: #FloatANSITest!

Transcript nextPutAll: 'Running the tests'; cr.
Transcript message: stdout -> #nextPutAllFlush:!


#(	"These tests fail!"
"NotificationANSITest"
	FloatANSITest
	FractionANSITest
	IntegerANSITest
	ScaledDecimalANSITest

ArrayANSITest
ArrayFactoryANSITest
BagANSITest
BagFactoryANSITest
BooleanANSITest
ByteArrayANSITest
ByteArrayFactoryANSITest
CharacterANSITest
CharacterFactoryANSITest
DateAndTimeANSITest
DateAndTimeFactoryANSITest
DictionaryANSITest
DictionaryFactoryANSITest
DurationANSITest
DurationFactoryANSITest
DyadicValuableANSITest
ErrorANSITest
ErrorClassANSITest
ExceptionANSITest
ExceptionClassANSITest
ExceptionSetANSITest
FailedMessageANSITest
FileStreamFactoryANSITest
FloatCharacterizationANSITest
FractionFactoryANSITest
IdentityDictionaryANSITest
IdentityDictionaryFactoryANSITest
IntervalANSITest
IntervalFactoryANSITest
MessageNotUnderstoodANSITest
MessageNotUnderstoodSelectorANSITest
MonadicBlockANSITest
NiladicBlockANSITest
NilANSITest
NotificationClassANSITest
ObjectANSITest
ObjectClassANSITest
OrderedCollectionANSITest
OrderedCollectionFactoryANSITest
ReadFileStreamANSITest
ReadStreamANSITest
ReadStreamFactoryANSITest
ReadWriteStreamANSITest
ReadWriteStreamFactoryANSITest
SelectorANSITest
SetANSITest
SetFactoryANSITest
SortedCollectionANSITest
SortedCollectionFactoryANSITest
StringANSITest
StringFactoryANSITest
SymbolANSITest
TranscriptANSITest
WarningANSITest
WarningClassANSITest
WriteFileStreamANSITest
WriteStreamANSITest
WriteStreamFactoryANSITest
ZeroDivideANSITest
ZeroDivideFactoryANSITest)
    do: [ :each || results |
	results := (Smalltalk at: each) suite run.
	Transcript showCr: ('%1: %2' bindWith: each with: results printString).
	results failureCount > 0 ifTrue: [ results failures printNl ].
	results errorCount > 0 ifTrue: [ results errors printNl ].
	results correctCount < results runCount ifTrue: [ Transcript showCr: '---' ]
    ]!
